//
//  NSDictionary+SortDictionary.h
//  Sort NSDictionary
//
//  Created by admin on 2014/12/31.
//  Copyright (c) 2014年 Eveian. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef NS_ENUM(NSInteger, SortType) {
    SortTypeABC = 0,    //字首字母排序
    SortTypeNumber,     //数字排序
    SortTypeDate,       //日期排序
};
@interface NSDictionary (SortDictionary)

/**
 *  自定义排序的方式
 *
 *  @param sortType 按字母还是数字大小
 *  @param key      排序的key值
 *  @param isASC    YES=降序,NO=升序
 *
 *  @return 排序过后的结果
 */
-(NSArray*) sortByType:(SortType)sortType key:(NSString*)key isASC:(BOOL)isASC;
@end
