//
//  NSDictionary+SortDictionary.m
//  Sort NSDictionary
//
//  Created by admin on 2014/12/31.
//  Copyright (c) 2014年 Eveian. All rights reserved.
//

#import "NSDictionary+SortDictionary.h"

@implementation NSDictionary (SortDictionary)


-(NSArray*) sortByType:(SortType)sortType key:(NSString*)key isASC:(BOOL)isASC{
    //sortKeys 为排序过后的键值
    NSArray* sortKeys = nil;
    switch (sortType) {
        case SortTypeABC:
            sortKeys= [self getABCSortKeys:key isASC:isASC];
            break;
        case SortTypeNumber:
            sortKeys= [self getNumberSortKeys:key isASC:isASC];
            break;
        case SortTypeDate:
            sortKeys= [self getDateSortKeys:key isASC:isASC];
            break;
        default:
            break;
    }
    NSMutableArray* reslutItems = [@[]mutableCopy];
    if (sortKeys) {
        //依据排序过后的键值重新建立一个array 回传
        [sortKeys enumerateObjectsUsingBlock:^(NSString* key, NSUInteger idx, BOOL *stop) {
            [reslutItems addObject:[self objectForKey:key]];
        }];
    }
    NSLog(@"排序后 依照 %@ %@:%@",key,isASC?@"降序":@"升序",reslutItems);
    return sortKeys?reslutItems:nil;
}

// -----------------------------------------------------------------------------------------------------------------
//按照第一個字母大小排序
-(NSArray*) getABCSortKeys:(NSString*)dicKey isASC:(BOOL)isASC{
    return [self keysSortedByValueUsingComparator:^NSComparisonResult(id obj1, id obj2) {
        NSString *first = [[obj1 valueForKey:dicKey] substringToIndex:1];
        NSString *second =[[obj2 valueForKey:dicKey] substringToIndex:1];

        NSComparisonResult r = [first localizedCaseInsensitiveCompare:second];
        
        if (r == NSOrderedAscending ) return (isASC?NSOrderedDescending:NSOrderedAscending);
        else if (r==NSOrderedDescending) return (isASC?NSOrderedAscending:NSOrderedDescending);
        else return NSOrderedSame;
    }];
}

// -----------------------------------------------------------------------------------------------------------------
//按照数字大小排序
-(NSArray*) getNumberSortKeys:(NSString*)dicKey isASC:(BOOL)isASC{
    return [self keysSortedByValueUsingComparator: ^(id obj1, id obj2) {
        if ([[obj1 objectForKey:dicKey] intValue] > [[obj2 objectForKey:dicKey] intValue]) {
            return (NSComparisonResult)isASC?NSOrderedAscending:NSOrderedDescending;
        }
        if ([[obj1 objectForKey:dicKey] intValue] < [[obj2 objectForKey:dicKey] intValue]) {
            return (NSComparisonResult)isASC?NSOrderedDescending:NSOrderedAscending;
        }
        return (NSComparisonResult)NSOrderedSame;
    }];
}

// -----------------------------------------------------------------------------------------------------------------
//按照日期大小排序
-(NSArray*) getDateSortKeys:(NSString*)dicKey isASC:(BOOL)isASC{
    return [self keysSortedByValueUsingComparator: ^(id obj1, id obj2) {
        NSDate *first = [obj1 valueForKey:dicKey] ;
        NSDate *second = [obj2 valueForKey:dicKey] ;
        if (first==nil || second ==nil) return NSOrderedAscending;
        
        NSInteger interval = [[[NSCalendar currentCalendar] components: NSCalendarUnitSecond
                                                              fromDate: first
                                                                toDate: second
                                                               options: 0] second];
        if (interval>0) return (isASC?NSOrderedDescending:NSOrderedAscending);
        else if (interval<0) return (isASC?NSOrderedAscending:NSOrderedDescending);
        else return NSOrderedSame;
    }];
}
@end
