//
//  ViewController.m
//  Sort NSDictionary
//
//  Created by admin on 2014/12/31.
//  Copyright (c) 2014年 Eveian. All rights reserved.
//

#import "ViewController.h"
#import "NSDictionary+SortDictionary.h"

static NSString* const kTempString = @"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890";
static NSInteger const kDictionaryCount = 5;  //总共几笔资料

@interface ViewController ()
@property(strong, nonatomic) NSDictionary* sourceDictionary;
@end

@implementation ViewController

//随便建立一个Dictionary,每一个key里面又包含了子Dictionary
-(NSDictionary*) sourceDictionary{
    if (!_sourceDictionary) {
        NSMutableDictionary* parentDic = [@{}mutableCopy];
        for (int i =0; i < kDictionaryCount; ++i) {
            NSMutableDictionary* subDic = [@{}mutableCopy];
            [subDic setObject:@(i) forKey:@"id"];
            [subDic setObject:[self randomString:5] forKey:@"any_string"];
            [subDic setObject:@(arc4random()%1000) forKey:@"any_number"];
            [subDic setObject:[self randDate] forKey:@"any_date"];
            [parentDic setObject:subDic forKey:[self randomString:5]];
        }
        _sourceDictionary = [[NSDictionary alloc] initWithDictionary:parentDic];
    }
    NSLog(@"排序前 :%@",_sourceDictionary);
    return _sourceDictionary;
}

-(NSString *) randomString: (int) len {
    NSMutableString *randomString = [NSMutableString stringWithCapacity: len];
    for (int i=0; i<len; i++) {
        [randomString appendFormat: @"%C", [kTempString characterAtIndex: arc4random() % [kTempString length]]];
    }
    return randomString;
}

-(NSDate*) randDate{
    NSTimeInterval interval = 60*60*24;
    NSTimeInterval randomInterval = random()% (int)interval;
    return [[NSDate date] dateByAddingTimeInterval:randomInterval];
}
- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    NSArray* sortByIDResult = [self.sourceDictionary sortByType:SortTypeNumber key:@"id" isASC:YES];
    NSLog(@"----------------------------------------------------------------------------");
    NSArray* sortByStringResult = [self.sourceDictionary sortByType:SortTypeABC key:@"any_string" isASC:YES];
    NSLog(@"----------------------------------------------------------------------------");
    NSArray* sortByDateResult = [self.sourceDictionary sortByType:SortTypeDate key:@"any_date" isASC:YES];
    NSLog(@"----------------------------------------------------------------------------");
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
